package xyz.tbvns.ui.Elements;

import com.badlogic.gdx.Gdx;
import imgui.ImGui;
import imgui.flag.ImGuiWindowFlags;
import org.lwjgl.util.tinyfd.TinyFileDialogs;
import tv.wunderbox.nfd.awt.AwtFileDialog;
import tv.wunderbox.nfd.nfd.NfdFileDialog;
import xyz.tbvns.Editor.ModelsManager;
import xyz.tbvns.Models.Animation;
import xyz.tbvns.Models.GDModel;
import xyz.tbvns.ui.Element;
import xyz.tbvns.ui.Renderable;

import java.awt.*;
import java.io.File;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;

public class ModelsList implements Element {
    @Override
    public void render() {
        ImGui.begin("Menu", ImGuiWindowFlags.NoDecoration | ImGuiWindowFlags.NoMove);
        ImGui.setWindowSize(200, Gdx.graphics.getHeight() - 19 - 200);
        ImGui.setWindowPos(0, 19);

        ImGui.beginTabBar("modelbar");
        modelsTab();
        ImGui.endTabBar();


        ImGui.end();
    }

    public void modelsTab() {
        ImGui.beginTabItem("Models");
        loadButton();
        modelsButtons();
        ImGui.endTabItem();
    }

    public void loadButton() {
        if (ImGui.button("Load a model")) {
            try {
                String path = TinyFileDialogs.tinyfd_selectFolderDialog("Select animation folder:", System.getProperty("user.home"));
                if (path!=null) {
                    ModelsManager.addAnimated(
                            new File(
                                    path
                            )
                    );
                }
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
    }

    public void modelsButtons() {
        List<Renderable> renderables = new ArrayList<>();
        for (GDModel model : ModelsManager.models) {
            renderables.add(model);
        }
        for (Animation animation : ModelsManager.animations) {
            renderables.add(animation);
        }
        ImGui.text("Available models:");
        for (Renderable renderable : renderables) {
            renderable.render();
        }
    }
}
