package xyz.tbvns.Managers;

import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;

public class ConfigManager {
    public static HashMap<String, String> read(String config) {
        HashMap<String, String> hashMap = new HashMap<>();
        String[] data = config.split("\n");
        for (String s : data) {
            String[] st = s.replace(" ", "").replace(String.valueOf((char) 13), "").split(":");
            if (st.length == 2) {
                hashMap.put(st[0], st[1]);
            } else {
                throw new RuntimeException("Invalide config file !");
            }
        }
        return hashMap;
    }

    public static HashMap<Integer, File> parsedTextureMap(HashMap<String, String> hashMap) {
        HashMap<Integer, File> data = new HashMap();
        hashMap.forEach((k, v) -> {
            data.put(Integer.parseInt(k), new File(FilesManager.getTextureFolder() + "/" + v));
        });
        return data;
    }

    public static void write(File file, HashMap<String, String> hashMap) throws IOException {
        StringBuilder data = new StringBuilder();
        hashMap.forEach((k, v) -> {
            data.append(k).append(":").append(v).append("\n");
        });
        FileUtils.writeStringToFile(file, data.toString(), StandardCharsets.UTF_8);
    }
}
